]> git.decadent.org.uk Git - dak.git/blob - config/debian-security/cron.unchecked
Only move accepted files in cron.unchecked
[dak.git] / config / debian-security / cron.unchecked
1 #! /bin/bash
2
3 set -e
4 set -o pipefail
5 set -u
6
7 export SCRIPTVARS=/srv/security-master.debian.org/dak/config/debian-security/vars
8 . $SCRIPTVARS
9
10 # And use one locale, no matter what the caller has set
11 export LANG=C
12 export LC_ALL=C
13
14 report=$queuedir/REPORT
15 reportdis=$queuedir/REPORT.disembargo
16 timestamp=$(date "+%Y-%m-%d %H:%M")
17 doanything=false
18 dopolicy=false
19 LOCKFILE="$lockdir/unchecked.lock"
20
21 # So first we should go and see if any process-policy action is done
22 dak process-policy embargoed | mail -a "X-Debian: DAK" -e -s "Automatically accepted from embargoed" team@security.debian.org -- -F "Debian FTP Masters" -f ftpmaster@ftp-master.debian.org
23 dak process-policy unembargoed | mail -a "X-Debian: DAK" -e -s "Automatically accepted from unembargoed" team@security.debian.org -- -F "Debian FTP Masters" -f ftpmaster@ftp-master.debian.org
24
25 # Now, if this really did anything, we can then sync it over. Files
26 # in newstage mean they are (late) accepts of security stuff, need
27 # to sync to ftp-master
28
29 cleanup() {
30     rm -f "$LOCKFILE"
31 }
32
33 if ! lockfile -r8 "$LOCKFILE"; then
34     echo "aborting cron.unchecked because $LOCKFILE has already been locked"
35     exit 0
36 fi
37 trap cleanup EXIT
38
39 for queue in embargoed; do
40     echo "$timestamp: processing ${queue}" >> ${report}
41     dak process-policy ${queue} >> ${report}
42     accepted=$(find ${queuedir}/accepted -type f -name "*.changes")
43     if [ -n "${accepted}" ]; then
44         dopolicy=true
45     fi
46 done
47
48 cd $unchecked
49 changes=$(find . -maxdepth 1 -mindepth 1 -type f -name \*.changes | sed -e "s,./,," | xargs)
50 if [ -n "$changes" ]; then
51     doanything=true
52     echo "$timestamp": ${changes:-"Nothing to do in unchecked"}  >> $report
53     dak process-upload -a -d "$unchecked" >> $report
54 fi
55
56 cd $disembargo
57 changes=$(find . -maxdepth 1 -mindepth 1 -type f -name \*.changes | sed -e "s,./,," | xargs)
58
59 if [ -n "$changes" ]; then
60     doanything=true
61     echo "$timestamp": ${changes:-"Nothing to do in disembargo"}  >> $reportdis
62     dak process-upload -a -d "$disembargo" >> $reportdis
63 fi
64
65 # sync accepted files to ftpmaster
66 cd ${base}
67 find ${queuedir}/accepted -type f -exec mv -t /srv/queued/ftpmaster '{}' +
68
69 if [ "${doanything}" = "false" ] && [ "${dopolicy}" = "false" ]; then
70     echo "$timestamp": Nothing to do >> $report
71     exit 0
72 fi
73
74 # export policy queues
75 for queue in embargoed; do
76     pushd ${queuedir}/${queue}
77     rm -rf export.new
78     dak export -q ${queue} -d export.new --all
79     rsync -a --delete export.new/. export/.
80     rm -rf export.new
81     popd
82 done
83
84 # manage build queues
85 dak manage-build-queues -a
86 dak generate-packages-sources2 -a build-queues
87 dak generate-releases -a build-queues >/dev/null
88
89 # export build queues in old format
90 # XXX: This should be removed later.
91 for suite in stable testing; do
92     overridecodename=$(dak admin suite show ${suite} | awk '$1 == "OverrideCodename:" { print $2 }')
93     rm -rf ${incoming}/${suite}.new
94     dak export-suite -s buildd-${suite} -d ${incoming}/${suite}.new
95
96     cd ${incoming}/${suite}.new
97     apt-ftparchive packages . ${overridedir}/override.${overridecodename}.all3 >Packages
98     gzip -9c --rsyncable <Packages >Packages.gz
99     apt-ftparchive sources . ${overridedir}/override.${overridecodename}.all3 >Sources
100     gzip -9c --rsyncable <Sources >Sources.gz
101     rm -f Release
102
103     cd ${incoming}
104     apt-ftparchive -qq -o APT::FTPArchive::Release::Origin="Debian" -o APT::FTPArchive::Release::Label="Debian" -o APT::FTPArchive::Release::Description="buildd $suite security" -o APT::FTPArchive::Release::Architectures="$archs" release ${suite}.new >${suite}.Release
105
106     gpg --secret-keyring /srv/security-master.debian.org/s3kr1t/dot-gnupg/secring.gpg --keyring /srv/security-master.debian.org/s3kr1t/dot-gnupg/pubring.gpg --no-options --batch --no-tty --armour --default-key 473041FA --detach-sign -o ${suite}.Release.gpg ${suite}.Release
107
108     mv ${suite}.Release ${suite}.new/Release
109     mv ${suite}.Release.gpg ${suite}.new/Release.gpg
110
111     if [ -d ${suite} ]; then
112         mv ${suite} ${suite}.old
113     fi
114     mv ${suite}.new ${suite}
115     rm -rf ${suite}.old
116 done
117
118 if [ "x${dopolicy}x" = "xtruex" ]; then
119     # We had something approved from a policy queue, push out new archive
120     dak dominate
121     #dak generate-filelist
122     cd $configdir
123     $configdir/map.sh
124     #apt-ftparchive generate apt.conf
125     dak generate-packages-sources2 -a security
126     dak generate-releases -a security
127     /srv/security-master.debian.org/dak/config/debian-security/make-mirror.sh
128     sudo -u archvsync -H /home/archvsync/signal_security
129 fi
130
131 cleanup
132 trap - EXIT
133
134 $configdir/cron.buildd